
/*
	These are example objects designed to show how to implement
	crafting.

	A few interesting or important features have been noted but
	it's mostly self explanitory.
*/

obj/Item
	icon = 'Icons.dmi'

	canCraft()
		if(usr.frozen) return 0
		return ..()

	whileCrafting()
		usr.frozen = 1
		usr << "*crafting noises*"
		sleep(30)
		usr << "You get a new item!"
		usr.frozen = 0

	// Spears have been given a stack size of 2 to demo easily how it works
	Spear
		icon_state = "Spear"
		stackable = 1
		stackSize = 2
		components = list(/obj/Item/Branch = 1, /obj/Item/Stone = 1)
		tools = list(/obj/Item/Knife)
		craftedAt = list(/obj/Station/Crafting_Table)

	Flag
		icon_state = "Flag"
		stackable = 1
		components = list(/obj/Item/Branch = 1, /obj/Item/Cloth = 3)
		craftedAt = list(/obj/Station/Crafting_Table)

	Sword
		icon_state = "Sword"
		components = list(/obj/Item/Iron_Bar = 1)
		craftedAt = list(/obj/Station/Furnace)

	Popcorn
		icon_state = "Popcorn"
		components = list(/obj/Item/Kernals = 1)

	// Stones have been given a stack size of 20 to also help demonstrate
	Stone
		icon_state = "Stone"
		stackable = 1
		stackSize = 20
		componentof = list(/obj/Item/Spear)

	Cloth
		icon_state = "Cloth"
		stackable = 1
		componentof = list(/obj/Item/Flag)

	Branch
		icon_state = "Branch"
		stackable = 1
		componentof = list(/obj/Item/Spear, /obj/Item/Flag)

	Iron_Bar
		icon_state = "Iron Bar"
		stackable = 1
		stackSize = 50
		componentof = list(/obj/Item/Sword)

	Kernals
		icon_state = "Kernals"
		stackable = 1
		stackSize = 20

	/*
		 Knifes don't stack and are made from components that don't stack.
		 This system will always work no matter if what you're crafting
		 stacks or if your components stack. It should be 100% stacking
		 friendly.
	*/
	Knife
		icon_state = "Knife"
		components = list(/obj/Item/Blade = 1, /obj/Item/Handle = 1)

	Handle
		icon_state = "Handle"
		componentof = list(/obj/Item/Knife)

	Blade
		icon_state = "Blade"
		componentof = list(/obj/Item/Knife)
